Package org.apache.commons.jxpath.ri.model.beans

# Class NullPropertyPointer

java.lang.Object
org.apache.commons.jxpath.ri.model.NodePointer
org.apache.commons.jxpath.ri.model.beans.PropertyPointer
org.apache.commons.jxpath.ri.model.beans.NullPropertyPointer

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Comparable`, `Pointer`

public class NullPropertyPointer extends PropertyPointer
Pointer to a null property.

See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class org.apache.commons.jxpath.ri.model.beans.PropertyPointer

  `bean, propertyIndex, UNSPECIFIED_PROPERTY`

  ### Fields inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `index, locale, parent, UNKNOWN_NAMESPACE, WHOLE_COLLECTION`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `NullPropertyPointer(NodePointer parent)`
  Constructs a new NullPropertyPointer.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `asPath()`
  Returns an XPath that maps to this Pointer.
  `NodePointer`
  `createChild(JXPathContext context, QName qName, int index)`
  Called by a child pointer when it needs to create a parent object for a non-existent collection element.
  `NodePointer`
  `createChild(JXPathContext context, QName qName, int index, Object value)`
  Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node.
  `NodePointer`
  `createPath(JXPathContext context)`
  Called by a child pointer when it needs to create a parent object.
  `NodePointer`
  `createPath(JXPathContext context, Object value)`
  Called directly by JXPathContext.
  `Object`
  `getBaseValue()`
  Gets the value represented by the pointer before indexing.
  `Object`
  `getImmediateNode()`
  Returns the object the pointer points to; does not convert it to a "canonical" type.
  `int`
  `getLength()`
  If the property contains a collection, then the length of that collection, otherwise - 1.
  `QName`
  `getName()`
  Gets the name of this node.
  `int`
  `getPropertyCount()`
  Count the number of properties represented.
  `String`
  `getPropertyName()`
  Gets the property name.
  `String[]`
  `getPropertyNames()`
  Gets the names of the included properties.
  `NodePointer`
  `getValuePointer()`
  If this pointer manages a transparent container, like a variable, this method returns the pointer to the contents.
  `boolean`
  `isActual()`
  An actual pointer points to an existing part of an object graph, even if it is null.
  `protected boolean`
  `isActualProperty()`
  Tests whether this pointer references an actual property.
  `boolean`
  `isCollection()`
  Returns `true` if the value of the pointer is an array or a Collection.
  `boolean`
  `isContainer()`
  If true, this node is auxiliary and can only be used as an intermediate in the chain of pointers.
  `boolean`
  `isLeaf()`
  If true, this node does not have children
  `void`
  `setNameAttributeValue(String attributeValue)`
  Sets the name attribute.
  `void`
  `setPropertyIndex(int index)`
  Sets the property index.
  `void`
  `setPropertyName(String propertyName)`
  Sets the property name.
  `void`
  `setValue(Object value)`
  Converts the value to the required type and changes the corresponding object to that value.

  ### Methods inherited from class org.apache.commons.jxpath.ri.model.beans.PropertyPointer

  `compareChildNodePointers, equals, getBean, getImmediateValuePointer, getPropertyIndex, hashCode`

  ### Methods inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `attributeIterator, childIterator, clone, compareTo, createAttribute, escape, getAbstractFactory, getDefaultNamespaceURI, getImmediateParentPointer, getIndex, getLocale, getNamespaceResolver, getNamespaceURI, getNamespaceURI, getNode, getNodeSetByKey, getNodeValue, getParent, getPointerByID, getPointerByKey, getRootNode, getValue, handle, handle, isAttribute, isDefaultNamespace, isLanguage, isNode, isRoot, namespaceIterator, namespacePointer, newChildNodePointer, newNodePointer, printPointerChain, remove, setAttribute, setExceptionHandler, setIndex, setNamespaceResolver, testNode, toString, verify`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### NullPropertyPointer

    public NullPropertyPointer(NodePointer parent)
    Constructs a new NullPropertyPointer.
    Parameters:
      `parent` - pointer

- ## Method Details

  - ### asPath

    public String asPath()
    Description copied from class: `NodePointer`
    Returns an XPath that maps to this Pointer.
    Specified by:
      `asPath` in interface `Pointer`
    Overrides:
      `asPath` in class `NodePointer`
    Returns:
      String XPath expression

  - ### createChild

    public NodePointer createChild(JXPathContext context, QName qName, int index)
    Description copied from class: `NodePointer`
    Called by a child pointer when it needs to create a parent object for a non-existent collection element. It may have to expand the collection, then create an element object and return a new pointer describing the newly created element.
    Overrides:
      `createChild` in class `PropertyPointer`
    Parameters:
      `context` - the owning JXPathCOntext
      `qName` - the QName at which a child should be created
      `index` - child index.
    Returns:
      created NodePointer

  - ### createChild

    public NodePointer createChild(JXPathContext context, QName qName, int index, Object value)
    Description copied from class: `NodePointer`
    Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node. This method may have to expand the collection in order to assign the element.
    Overrides:
      `createChild` in class `PropertyPointer`
    Parameters:
      `context` - the owning JXPathCOntext
      `qName` - the QName at which a child should be created
      `index` - child index.
      `value` - node value to set
    Returns:
      created NodePointer

  - ### createPath

    public NodePointer createPath(JXPathContext context)
    Description copied from class: `NodePointer`
    Called by a child pointer when it needs to create a parent object. Must create an object described by this pointer and return a new pointer that properly describes the new object.
    Overrides:
      `createPath` in class `PropertyPointer`
    Parameters:
      `context` - the owning JXPathContext
    Returns:
      created NodePointer

  - ### createPath

    public NodePointer createPath(JXPathContext context, Object value)
    Description copied from class: `NodePointer`
    Called directly by JXPathContext. Must create path and set value.
    Overrides:
      `createPath` in class `PropertyPointer`
    Parameters:
      `context` - the owning JXPathContext
      `value` - the new value to set
    Returns:
      created NodePointer

  - ### getBaseValue

    public Object getBaseValue()
    Description copied from class: `NodePointer`
    Gets the value represented by the pointer before indexing. So, if the node represents an element of a collection, this method returns the collection itself.
    Specified by:
      `getBaseValue` in class `NodePointer`
    Returns:
      Object value

  - ### getImmediateNode

    public Object getImmediateNode()
    Description copied from class: `NodePointer`
    Returns the object the pointer points to; does not convert it to a "canonical" type.
    Overrides:
      `getImmediateNode` in class `PropertyPointer`
    Returns:
      Object node

  - ### getLength

    public int getLength()
    Description copied from class: `PropertyPointer`
    If the property contains a collection, then the length of that collection, otherwise - 1.
    Overrides:
      `getLength` in class `PropertyPointer`
    Returns:
      int length

  - ### getName

    public QName getName()
    Description copied from class: `NodePointer`
    Gets the name of this node. Can be null.
    Overrides:
      `getName` in class `PropertyPointer`
    Returns:
      QName The name of this node. Can be null.

  - ### getPropertyCount

    public int getPropertyCount()
    Description copied from class: `PropertyPointer`
    Count the number of properties represented.
    Specified by:
      `getPropertyCount` in class `PropertyPointer`
    Returns:
      int

  - ### getPropertyName

    public String getPropertyName()
    Description copied from class: `PropertyPointer`
    Gets the property name.
    Specified by:
      `getPropertyName` in class `PropertyPointer`
    Returns:
      String property name.

  - ### getPropertyNames

    public String[] getPropertyNames()
    Description copied from class: `PropertyPointer`
    Gets the names of the included properties.
    Specified by:
      `getPropertyNames` in class `PropertyPointer`
    Returns:
      String[]

  - ### getValuePointer

    public NodePointer getValuePointer()
    Description copied from class: `NodePointer`
    If this pointer manages a transparent container, like a variable, this method returns the pointer to the contents. Only an auxiliary (non-node) pointer can (and should) return a value pointer other than itself. Note that you probably don't want to override `getValuePointer()` directly. Override the `getImmediateValuePointer()` method instead. The `getValuePointer()` method is calls `getImmediateValuePointer()` and, if the result is not `this`, invokes `getValuePointer()` recursively. The idea here is to open all nested containers. Let's say we have a container within a container within a container. The `getValuePointer()` method should then open all those containers and return the pointer to the ultimate contents. It does so with the above recursion.
    Overrides:
      `getValuePointer` in class `NodePointer`
    Returns:
      NodePointer

  - ### isActual

    public boolean isActual()
    Description copied from class: `NodePointer`
    An actual pointer points to an existing part of an object graph, even if it is null. A non-actual pointer represents a part that does not exist at all. For instance consider the pointer "/address/street". If both address and street are not null, the pointer is actual. If address is not null, but street is null, the pointer is still actual. If address is null, the pointer is not actual. (In JavaBeans) if address is not a property of the root bean, a Pointer for this path cannot be obtained at all - actual or otherwise.
    Overrides:
      `isActual` in class `PropertyPointer`
    Returns:
      boolean

  - ### isActualProperty

    protected boolean isActualProperty()
    Description copied from class: `PropertyPointer`
    Tests whether this pointer references an actual property.
    Specified by:
      `isActualProperty` in class `PropertyPointer`
    Returns:
      true if actual

  - ### isCollection

    public boolean isCollection()
    Description copied from class: `NodePointer`
    Returns `true` if the value of the pointer is an array or a Collection.
    Overrides:
      `isCollection` in class `PropertyPointer`
    Returns:
      boolean

  - ### isContainer

    public boolean isContainer()
    Description copied from class: `NodePointer`
    If true, this node is auxiliary and can only be used as an intermediate in the chain of pointers.
    Overrides:
      `isContainer` in class `NodePointer`
    Returns:
      boolean

  - ### isLeaf

    public boolean isLeaf()
    Description copied from class: `NodePointer`
    If true, this node does not have children
    Overrides:
      `isLeaf` in class `PropertyPointer`
    Returns:
      boolean

  - ### setNameAttributeValue

    public void setNameAttributeValue(String attributeValue)
    Sets the name attribute.
    Parameters:
      `attributeValue` - value to set

  - ### setPropertyIndex

    public void setPropertyIndex(int index)
    Description copied from class: `PropertyPointer`
    Sets the property index.
    Overrides:
      `setPropertyIndex` in class `PropertyPointer`
    Parameters:
      `index` - property index

  - ### setPropertyName

    public void setPropertyName(String propertyName)
    Description copied from class: `PropertyPointer`
    Sets the property name.
    Specified by:
      `setPropertyName` in class `PropertyPointer`
    Parameters:
      `propertyName` - property name to set.

  - ### setValue

    public void setValue(Object value)
    Description copied from class: `NodePointer`
    Converts the value to the required type and changes the corresponding object to that value.
    Specified by:
      `setValue` in interface `Pointer`
    Specified by:
      `setValue` in class `NodePointer`
    Parameters:
      `value` - the value to set